VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMDBInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements OLEDBSimpleProvider
Dim m_RS As ADODB.Recordset
Dim iosp As OLEDBSimpleProviderListener

Public Command As String
Public DB As String

Private Function OLEDBSimpleProvider_deleteRows(ByVal iRow As Long, ByVal cRows As Long) As Long
'
End Function

Private Function OLEDBSimpleProvider_find(ByVal iRowStart As Long, ByVal iColumn As Long, ByVal val As Variant, ByVal findFlags As std.OSPFIND, ByVal compType As std.OSPCOMP) As Long
'
End Function

Private Function _
    OLEDBSimpleProvider_getColumnCount() As Long
 OLEDBSimpleProvider_getColumnCount = 3
End Function
Private Function _
    OLEDBSimpleProvider_getEstimatedRows() As Long
 OLEDBSimpleProvider_getEstimatedRows = m_RS.RecordCount
End Function

Private Function OLEDBSimpleProvider_getLocale() As String
'
End Function

Private Function OLEDBSimpleProvider_getRowCount() As Long
 OLEDBSimpleProvider_getRowCount = m_RS.RecordCount
End Function

Private Function OLEDBSimpleProvider_getRWStatus(ByVal iRow As Long, ByVal iColumn As Long) As std.OSPRW
OLEDBSimpleProvider_getRWStatus = OSPRW_READONLY
End Function

Private Function OLEDBSimpleProvider_getVariant(ByVal iRow As Long, ByVal iColumn As Long, ByVal format As std.OSPFORMAT) As Variant
  iosp.aboutToChangeCell iRow, iColumn
  m_RS.AbsolutePosition = iRow + 1
  OLEDBSimpleProvider_getVariant = m_RS(iColumn - 1)
  iosp.cellChanged iRow, iColumn
End Function

Private Function OLEDBSimpleProvider_insertRows(ByVal iRow As Long, ByVal cRows As Long) As Long
'
End Function

Private Function OLEDBSimpleProvider_isAsync() As Long
'
End Function
Private Sub OLEDBSimpleProvider_setVariant(ByVal iRow As Long, ByVal iColumn As Long, ByVal format As std.OSPFORMAT, ByVal var As Variant)

  m_RS.AbsolutePosition = iRow + 1
  m_RS.Fields(iColumn - 1) = var
End Sub

Private Sub OLEDBSimpleProvider_stopTransfer()
'
End Sub

Public Sub CreateRecordset()
Dim dbs As DAO.Database
Dim col As Object
Dim itm As Object

Set dbs = OpenDatabase(DB)
Select Case Command
    Case "Form"
        Set col = dbs.Containers("Forms").Documents
    Case "Report"
        Set col = dbs.Containers("Reports").Documents
    Case "Query"
        Set col = dbs.QueryDefs
End Select

Set m_RS = New ADODB.Recordset
m_RS.Fields.Append "Name", adVarChar, 25
m_RS.Fields.Append "DateCreated", adVarChar, 20
m_RS.Fields.Append "DateModified", adVarChar, 20
m_RS.Open

m_RS.AddNew
m_RS(0) = "Name"
m_RS(1) = "DateCreated"
m_RS(2) = "LastUpdated"

For Each itm In col
    m_RS.AddNew
    m_RS("Name") = itm.Name
    m_RS("DateCreated") = itm.DateCreated
    m_RS("DateModified") = itm.LastUpdated
Next

End Sub

Private Sub OLEDBSimpleProvider_removeOLEDBSimpleProviderListener _
  (ByVal pospIListener As _
    OLEDBSimpleProviderListener)
 Set iosp = Nothing
End Sub

Private Sub OLEDBSimpleProvider_addOLEDBSimpleProviderListener _
    (ByVal pospIListener As _
     OLEDBSimpleProviderListener)
Set iosp = pospIListener
End Sub



